"""
This file will be placed at the root of the submission repo during evaluation.

The mount location of the file can be updated using `aicrowd.yaml`.
"""

import os
from evaluation_utils.mnist_evaluator import MNISTEvaluator

# Import participant's prediction class
from run import MNISTPredictor


def main():
    evaluator = MNISTEvaluator(
        test_data_path=os.getenv("AICROWD_DATASET_PATH", "data/images"),
        predictions_file_path=os.getenv(
            "AICROWD_PREDICTIONS_FILE", "data/shared/predictions.csv"
        ),
        ground_truth_data_path=os.getenv(
            "AICROWD_GROUND_TRUTH_PATH",
            os.path.join(os.getenv("AICROWD_DATASET_PATH", "data"), "fake_labels.csv"),
        ),
        predictor=MNISTPredictor(),
    )
    evaluator.evaluation()


if __name__ == "__main__":
    main()
